require 'sketchup.rb' 
module IT_TL
def self.ithil_translit
model = Sketchup.active_model
selection = model.active_entities
		model.start_operation("Translit",true)
		puts "Using enhanced speed mode"
Sketchup.set_status_text "Program is running..."
model.start_operation("Translit")
model.pages.each { |m| m.name = self.russian_translit(m.name)}
model.layers.each { |m| m.name = self.russian_translit(m.name)}
model.materials.each_with_index { |m,i| m.name = self.russian_translit(m.name) }
model.definitions.each { |m| m.name = self.russian_translit(m.name) }
self.process_at_level_translit selection, {}
Sketchup.set_status_text "Done!"
model.commit_operation
  end#def

 def self.process_at_level_translit(entities, hcomp)
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			entity.name= self.russian_translit(entity.name)
			self.process_at_level_translit entity.entities, hcomp
		when 'ComponentInstance'
			edef = entity.definition
			next if hcomp[edef.to_s]
			hcomp[edef.to_s] = edef
			self.process_at_level_translit edef.entities, hcomp
		end
	end
end

def self.russian_translit(text)
    translited = text.tr('абвгдеёзийклмнопрстуфхэыьъ', 'abvgdeezijklmnoprstufhey\'\'')
													   
    translited = translited.tr('АБВГДЕЁЗИЙКЛМНОПРСТУФХЭЫЬЪ', 'ABVGDEEZIJKLMNOPRSTUFHEYY\'\'\'')

    translited = translited.gsub(/[жцчшщъюяЖЦЧШЩЪЮЯ]/,
        'ж' => 'zh', 'ц' => 'ts', 'ч' => 'ch', 'ш' => 'sh', 'щ' => 'sch', 'ъ' => '', 'ю' => 'ju', 'я' => 'ja',
        'Ж' => 'ZH', 'Ц' => 'TS', 'Ч' => 'CH', 'Ш' => 'SH', 'Щ' => 'SCH', 'Ъ' => '', 'Ю' => 'JU', 'Я' => 'JA')
    return translited
end
end #module IR
		plugins = Sketchup.find_support_file("Plugins")
		folder="ithil_tools"
		icon_translit = File.join(plugins,folder, "translit_l.png")
		icon_s_translit = File.join(plugins,folder, "translit_s.png")

		
It_tb = UI::Toolbar.new("Translit")

		ith_translit = UI::Command.new("Ithil Translit"){IT_TL.ithil_translit}
		ith_translit.small_icon = icon_s_translit
		ith_translit.large_icon = icon_translit
		ith_translit.tooltip = "Translit Layers, Materials, Group, Scene and Component"
		ith_translit.status_bar_text = "Transliterate Cyrillic letters to represent them in Latin characters"

It_tb.add_item(ith_translit)
It_tb.show

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Rename Material"){IT_TL.ithil_translit}
		end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("Translit"){IT_TL.ithil_translit}

	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)